Import bah.freeimage
SuperStrict

Graphics 800,600
SetBlend ALPHABLEND
AppTitle = "PocketLight"

Global tileset:TImage = LoadAnimImage (LoadMyIMage("gfx/tileset.png").pixmaps[0],32,32,0,3)
Global PocketLight:TImage = LoadMyIMage("gfx/pocketlight.png")
MidHandleImage PocketLight
Global Blackhole:TImage = LoadMyIMage("gfx/blackhole.png")
MidHandleImage Blackhole
Global Button:TImage = LoadMyIMage("gfx/button.png")
MidHandleImage Button
Global Portal:TImage = LoadMyIMage("gfx/Portal.png")
Global Mirror:TImage = LoadMyIMage("gfx/Spiegel.png")
Global RealMirror:TImage = LoadMyIMage("gfx/mirror.png")
MidHandleImage RealMirror
Global RealPortal:TImage = LoadMyIMage("gfx/realportal.png")
MidHandleImage RealPortal
Global Disko:TImage = LoadMyImage("gfx/disko.png")
MidHandleImage Disko

Function LoadMyIMage:TImage(p:String)
	Return LoadImage(CopyPixmap(LoadFreeImage(p).pixmap))
EndFunction
Global txt:String
For Local i:Int = 0 To 25
	txt :+ "    "
Next
New TMenuState.Run()


Type TState Abstract
	Method Update() Abstract
	Method Render() Abstract
	Method Create() Abstract
	Method Remove() Abstract
	Field EndState:Byte = False
	Method Run()
		Create()
		Local timer:ttimer = CreateTimer(40)
		Repeat
			
			
			
			Update()
			Render()
			
			Flip 0
			Cls
			WaitTimer timer
		Until AppTerminate() Or EndState
		Remove()
	EndMethod
EndType

Type TMenuState Extends TState Final
	Field game:TGamestate = New TGamestate
	
	Method Update()
		If KeyHit(KEY_ESCAPE) End
	EndMethod
	Method Render()
		game.render()
		SetScale 2,2
		THud.DrawInfo "Pocketlight - Von coolo"+txt,10,10
		SetScale 1,1	
		If rectsoverlap(10,400,TextWidth("Starten"+txt)+20,TextHeight("")+20,MouseX(),MouseY(),1,1)
			If MouseDown(1) New TGameState.Run()
			SetAlpha .4
		EndIf
		THud.DrawInfo "Starten"+txt,10,400
		SetScale 1,1
		If rectsoverlap(10,500,TextWidth("Beenden"+txt)+20,TextHeight("")+20,MouseX(),MouseY(),1,1)
			If MouseDown(1) End
			SetAlpha .4
		EndIf
		THud.DrawInfo "Beenden"+txt,10,500
	EndMethod
	Method Create()
		game.Create()
		
		game.update()
		
		Game.Map.ScrollX :+ 200
		Game.Map.Scrolly :+ 200
		
	EndMethod
	Method Remove()
		game = Null
	EndMethod
EndType

Type TPauseState Extends TState Final
	Field Game:TGameState
	
	Method Update()
		If KeyHit(KEY_ESCAPE) EndState = True
	EndMethod
	Method Render()
		If Game Game.Render()
		SetScale 2,2
		THud.DrawInfo "Spielpause"+txt,10,10
		SetScale 1,1		
		If rectsoverlap(10,400,TextWidth("Weiter"+txt)+20,TextHeight("")+20,MouseX(),MouseY(),1,1)
			If MouseDown(1) EndState = True
			SetAlpha .4
		EndIf
		THud.DrawInfo "Weiter"+txt,10,400
		SetScale 1,1
		If rectsoverlap(10,500,TextWidth("Beenden"+txt)+20,TextHeight("")+20,MouseX(),MouseY(),1,1)
			If MouseDown(1) End
			SetAlpha .4
		EndIf
		THud.DrawInfo "Beenden"+txt,10,500
	EndMethod
	Method Create()
		
	EndMethod
	Method Remove()
		Game = Null
	EndMethod
EndType

Type TGameState Extends TState Final
	Field Map:TGameMap
	Field Objects:TList
	Field LastMouseX:Int, LastMouseY:Int
	Field Change:Byte
	Field HUD:THUD
	Field LastX:Float, LastY:Float
	Field CurLevel:Int = 0
	Field MXS:Int, MYS:Int, OSX:Int, OSY:Int
	Method Update()
		MXS = (MouseX() - LastMouseX)
		MYS = (MouseY() - LastMouseY)
		If MouseDown(1) And Not hud.selected
			OSX = Map.ScrollX
			OSY = Map.ScrollY
			Map.ScrollX :+ MXS
			Map.ScrollY :+ MYS
			
			If (Map.ScrollX - GraphicsWidth()) < -Map.Width*32  Map.ScrollX = -Map.Width*32 + GraphicsWidth() '- 16
			If (Map.ScrollY - GraphicsHeight()) < -Map.Height*32 Map.ScrollY = -Map.Height*32 + GraphicsHeight() '- 16
			
			If Map.ScrollX > 0 Map.ScrollX = 0
			If Map.ScrollY > 0 Map.ScrollY = 0
		EndIf
		LastMouseX = MouseX()
		LastMouseY = MouseY()

		Map.Update
		
		Local MaxiButton:Int = 0, ActiButton:Int = 0
		For Local Obj:TGameObject=EachIn Objects
			If tButton(obj)
				MaxiButton :+ 1
				ActiButton :+ TButton(Obj).isActi
			EndIf
			Obj.Update
		Next
		Hud.Update
		
		If MaxiButton = ActiButton
			For Local i:Float = 0 To 1 Step .005
				Render()
				SetColor 0,0,0
				SetAlpha i
				DrawRect 0,0,GraphicsWidth(),GraphicsHeight()
				SetAlpha 1
				SetColor 255,255,255
				Flip 0
				Cls
			Next
			LoadNextLevel
			For Local i:Float = 1 To 0 Step -.005
				Render()
				SetColor 0,0,0
				SetAlpha i
				DrawRect 0,0,GraphicsWidth(),GraphicsHeight()
				SetAlpha 1
				SetColor 255,255,255
				Flip 0
				Cls
			Next
		EndIf
	EndMethod
	
	Method Render()
		SetOrigin Map.ScrollX, Map.ScrollY
		TileImage Tileset,0,0,0
		For Local Obj:TGameObject=EachIn Objects
			Obj.Render
		Next
		
		Map.Render
		SetOrigin 0,0
		
		Hud.Render
	EndMethod
	
	Method Create()
		HUD = New THUD.Create(Self)
		loadnextlevel()
	EndMethod
	
	Method LoadNextLevel()
		Objects = New TList
		hud.data = Null
		hud.selected = Null
		Map = New TGameMap.Load(CurLevel)
		TPocketLight.MyStrength = 128
		HUD.Portals = 0
		HUd.Mirrors = 0
		hud.MaxDist = 256
		
		Select CurLevel
			Case 0
				Objects.AddLast New TPocketLight.Create(Self,64,64, 90)	
				Objects.addLast New TButton.Create(Self, 400,64)
				Hud.Portals = 1
				Hud.Mirrors = 1
			Case 1
				Objects.AddLAst New TPocketLight.Create(Self,405,70,180)
				Objects.AddLast New TButton.Create(Self,100,350)
				Hud.Mirrors = 2
			Case 2
				Objects.AddLast New TPocketLight.Create(Self, 500,360,90)
				Objects.AddLast New TBlackHole.Create(Self, 70,300)
				Objects.AddLast New TBlackHole.Create(Self, 180,200)
				Objects.AddLast New TBlackHole.Create(Self, 280,300)
				Objects.AddLast New TButton.Create(Self,500,250)
				Hud.Portals = 1
			Case 3
				TPocketLight.MyStrength = 160
				Objects.AddLast New TPocketLight.Create(Self,100,100,90)
				Objects.AddLast New TBlackHole.Create(Self,200,400)
				Objects.AddLast New TBlackHole.Create(Self,300,500)
				Objects.AddLast New TPocketLight.Create(Self,400,300,0)
				Objects.AddLast New TButton.Create(Self,500,500)
				Objects.AddLast New TButton.Create(Self,550,100)
				Hud.Mirrors = 3
				Hud.Portals = 0
			Case 4
				Objects.AddLast New TPocketLight.Create(Self,100,100,0)
				Objects.AddLast New TBlackHole.Create(Self,550,200)
				Objects.AddLast New TPocketLight.Create(Self,100,400,90)
				Objects.AddLast New TButton.Create(Self,550,320)
				Objects.AddLast New TButton.Create(Self,550,500)
				Hud.Portals = 1
				Hud.Mirrors = 2
			Case 5
				Objects.AddLast New TPocketLight.Create(Self,240,80,180)
				Objects.AddLast New TDiskoKugel.Create(Self,240,400)
				Objects.AddLast New TButton.Create(Self,424,251)
				Objects.AddLast New TButton.Create(Self,50,276)
				Objects.AddLast New TButton.Create(Self,49,409)
				Objects.AddLast New TButton.Create(Self,54,551)
				Objects.AddLast New TButton.Create(Self,189,566)
				Objects.AddLast New TButton.Create(Self,304,571)
				Objects.AddLast New TButton.Create(Self,353,475)
				Objects.AddLast New TButton.Create(Self,416,391)
				Objects.AddLast New TButton.Create(Self,331,56)				
			Case 6
				Objects.AddLast New TButton.Create(Self,730,310)
				Objects.AddLast New TPocketLight.Create(Self,80,100,90)
				Hud.Mirrors = 7
				Hud.Portals = 1
			Case 7
				Objects.AddLast New TButton.Create(Self,520,60)
				Objects.AddLast New TPocketLight.Create(Self,300,550,0)
				Objects.AddLast New TPocketLight.Create(Self,300,550,180)
				Objects.AddLast New TButton.Create(Self,100,60)
				Hud.Mirrors = 6
				Hud.Portals = 1
				Hud.MaxDist = 128
			Case 8
				TPocketLight.MyStrength = 200
				Objects.AddLast New TButton.Create(Self,200,250)
				Objects.AddLast New TButton.Create(Self,80,60)
				Objects.AddLast New TButton.Create(Self,70,500)
				Objects.addLast New TButton.Create(Self, 565,550)
				Objects.AddLast New TDiskoKugel.Create(Self,400,300)
				Objects.AddLast New TPocketLight.Create(Self,600,300,160)
				
				Hud.Mirrors = 5
				Hud.Portals = 1
			Case 9
				Objects.AddLast New TButton.Create(Self,840,900)
				Objects.AddLast New TButton.Create(Self,633,142)
				TPocketLight.MyStrength = 256
				Objects.AddLast New TPocketLight.Create(Self,120,100,90)
				Objects.AddLast New TPocketLight.Create(Self,120,100,180)
				TPocketLight.MyStrength = 128
				Objects.AddLast New TPocketLight.Create(Self,120,100,0)
				Objects.AddLast New TBlackHole.Create(Self, 412,115)
				Objects.AddLast New TBlackHole.Create(Self, 860,110)
				Objects.AddLast New TButton.Create(Self, 840,460)
				Hud.Mirrors = 10
				Hud.Portals = 1
			Case 10
				Objects.AddLast New TButton.Create(Self,870,80)
				Objects.AddLast New TButton.Create(Self,885,482)
				Objects.AddLast New Tbutton.Create(Self, 872,892)
				
				Objects.AddLast New TPocketLight.Create(Self, 100,100,0)
				Objects.AddLast New TPocketLight.Create(Self, 100,490,0)
				Objects.addLast New TPocketLight.Create(Self, 100,860,0)
				
				Hud.Mirrors = 6
				Hud.Portals = 1
			Case 11
				TPocketLight.myStrength = 200
				Objects.AddLast New TButton.Create(Self,1200,220)
				For Local i:Int = 200 To 1200 Step 200
					Objects.AddLast New TBlackHole.Create(Self,i,90)
					Objects.AddLast New TBlackHole.Create(Self,i,350)
				Next
				Objects.AddLast New TPocketLight.Create(Self,80,200,0)
				Hud.Mirrors = 6
			Case 12
				Objects.AddLast New TButton.Create(Self, 230,80)
				Objects.AddLast New TButton.Create(Self,380,80)
				Objects.AddLast New TPocketLight.Create(Self,180,550,180)
				Objects.AddLast New TPocketLight.Create(Self,420,550,0)
				Hud.portals = 2
				Hud.Mirrors = 10
				
			Case 13
				TPocketLight.MyStrength = 512
				Objects.AddLast New TButton.Create(Self, 100, 80)
				Objects.AddLast New TBlackHole.Create(Self, 60,410)
				Objects.AddLast New TPocketLight.Create(Self,60,250,0)
				Hud.Mirrors = 10
			Case 14
				Objects.AddLast New TButton.Create(Self, 1200,64)
				Objects.AddLast New TButton.Create(Self, 1200,209)
				Objects.AddLast New TButton.Create(Self, 1200,397)
				Objects.AddLast New TButton.Create(Self, 1200,566)
				Objects.AddLast New TPocketLight.Create(Self,200,100,0)
				Objects.AddLast New TPocketLight.Create(Self,200,210,45)
				Objects.AddLast New TPocketLight.Create(Self,200,400,90)
				Objects.AddLast New TPocketLight.Create(Self,200,560,90+45)
				Hud.MaxDist = 300
				Hud.Mirrors = 9
				Hud.Portals = 1
			Case 15
				Objects.AddLast New TButton.Create(Self,-100,-100)
		EndSelect
		
		
		RebuildRay
		CurLevel :+1
	EndMethod
	
	Method Remove()
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		For Local Obj:TGameObject= EachIn Objects
			LastX = Obj.X
			LastY = obj.Y
			If Obj.IsCollision(X,Y) Return True
		Next
		
		Return False
	EndMethod
	
	Method RebuildRay()
		InitRebuild()
		For Local Obj: TGameObject = EachIn Objects
			Obj.Rebuild()
		Next
	EndMethod
	
	
	Method InitRebuild()
		For Local Obj:TGameObject = EachIn Objects
			Obj.InitRebuild()
		Next
	EndMethod
EndType

Type THUD
	Global MaxDist:Int = 256
	Field Selected:TImage
	
	Field Game:TGameState
	Field Hover:Byte = False, Hover2:Byte = False
	Field Data:Float[]
	Field Portals:Int, Mirrors:Int
	Field TurnPoc:TPocketLight
	Method Update()
		If KeyHit(KEY_ESCAPE)
			Local s:TPauseState = New TPauseState
			s.game = game
			s.run
		EndIf
		If MouseHit(2) 
			data = Null
			selected = Null
			Game.RebuildRay
		EndIf
		Local zspeed:Int = MouseZSpeed()
		If selected <>mirror And zspeed
			For Local poc:TPocketlight=EachIn Game.Objects
				Poc.SetAngle Poc.GetAngle() + zspeed*2
			Next
		EndIf
		Local mh:Byte = MouseHit(1)
		If RectsOverlap(0,32,36,128,MouseX(),MouseY(),1,1)
			If Hover = 0 Hover = 1
			If Hover > 0 And Hover < 32
				Hover :+ 4
			EndIf
		ElseIf Hover > 0
			Hover :- 4
			If Hover > 128 Hover = 0
		EndIf
		If RectsOverlap(GraphicsWidth()-30-Hover2,20-5,200,TextHeight("")+10,MouseX(),MouseY(),1,1)
			If Hover2 = 0 Hover2 = 1
			If Hover2 > 0 And Hover2 < 64
				Hover2 :+ 4
			EndIf
			If Mh
				Game.CurLevel :- 1
				Game.LoadNextLevel()
				Mh = False
			EndIf
		ElseIf Hover2 > 0
			Hover2 :- 4
			If Hover2 > 128 Hover2 = 0
		EndIf
		If Mh
			For Local i:Int = 0 To 1
				If RectsOverlap(-40+Hover,32+i*70,64,64,MouseX(),MouseY(),1,1)
					Local osel:TImage = selected
					If selected
						data = Null
						selected = Null					
					EndIf
					data = Null
					Selected = TImage([Portal, Mirror][i])
					If osel = selected selected = Null
					Mh = False
				EndIf
			Next
		EndIf
		If Mh And Not selected
			For Local Obj:TGameObject=EachIn game.Objects
				If TPortal(Obj)
					Local del:Byte = False
					
					Local p:TPortal = TPortal(Obj)
					If GetDistance(Obj.X+16,Obj.Y+16,MouseX()-Game.Map.Scrollx,MouseY()-Game.Map.Scrolly)<32
						data = New Float[8]
						data[4] = p.x2
						data[5] = p.y2
						data[6] = p.angle2
						
						del = True
					ElseIf getdistance(p.X2+16,p.Y2+16,MouseX()-Game.Map.Scrollx,MouseY()-Game.Map.Scrolly)<32
						data = New Float[8]
						data[4] = p.x
						data[5] = p.y
						data[6] = p.angle
						
						del = True
					EndIf
					If del
						Game.Objects.Remove obj
						Game.RebuildRay
					
						Selected = portal
						Portals :+ 1
						Mh = False
						Exit
					EndIf
				ElseIf TMirror(Obj)
					If GetDistance(Obj.X,Obj.Y,MouseX()-Game.Map.Scrollx,MouseY()-Game.Map.Scrolly)<16
						Game.Objects.Remove obj
						Game.RebuildRay
						data = New Float[4]
						selected = mirror
						data[0] = TMirror(Obj).Angle-90
						Mirrors:+1
						Mh = False
						Exit
					EndIf
				EndIf
			Next
		EndIf
		If Hover>0 Mh = False
		Select Selected
			Case Portal
				If Portals = 0 
					Selected = Null
					Return
				EndIf
				If data= Null 
					data = New Float[8]
					data[4] = -1
					data[5] = -1
					data[6] = -1
				EndIf
				
				
				Local RealX:Float = MouseX()-Game.Map.ScrollX 
				Local RealY:Float = MouseY()-Game.Map.ScrollY 
				RealX = Floor(RealX/32.0)*32.0
				realY = Floor(RealY/32.0)*32.0
				data[0] = RealX
				data[1] = realy
				Local TmpX:Float = MouseX()-Game.Map.ScrollX , TmpY:Float = MouseY()-Game.Map.ScrollY
				If Game.Map.IsCollision(TmpX + 32,TmpY) ~ Game.Map.IsCollision(TmpX - 32, TmpY) ~ Game.Map.IsCollision(TmpX,TmpY-32) ~ Game.Map.IsCollision(TmpX,TmpY+32)
					If Game.Map.IsCollision(TmpX + 32,TmpY) Data[2] = 0
					If Game.Map.IsCollision(TmpX - 32,TmpY) Data[2] = 180
					If Game.Map.IsCollision(TmpX ,TmpY+32) Data[2] = 90
					If Game.Map.IsCollision(TmpX ,TmpY-32) Data[2] = 270
					RealX = MouseX() - Game.Map.ScrollX
					RealY = MouseY() - Game.Map.ScrollY
				Else
					Local AbsX:Float = RealX+ 16.0
					Local AbsY:Float = RealY+ 16.0
					RealX = MouseX() - Game.Map.ScrollX
					RealY = MouseY() - Game.Map.ScrollY
					Local Angle:Float = getAngle(RealX,RealY,AbsX,AbsY)
					'schauen ob nur ein teil umgibt (wenn ja, dann immer dieses teil nehmen)
					
					Data[2] = Floor((Angle+45)/90.0)*90
				EndIf
				
				
				data[3] = False
				If Game.Map.IsCollision(RealX + Cos(Data[2])*14,RealY + Sin(Data[2])*14)
					data[3]=True
				EndIf
				If GAme.Map.IsCollision(RealX,RealY) Data[3] = False
				Local dist:Float =  getdistance(data[4],data[5],data[0],data[1])
				Local dont:Byte = False
				If Mh And Data[3]
					If data[4] = -1 And data[5]=-1 And data[6]=-1
						data[4] = data[0]
						data[5] = data[1]
						data[6] = data[2]
					ElseIf dist < Maxdist
						Game.Objects.addlast New TPortal.Create(Game, Data[0], Data[1], Data[2], Data[4], Data[5], Data[6])
						Game.RebuildRay()
						Selected = Null
						data = Null
						Portals :- 1
					EndIf
				ElseIf data[3]
					If dist<maxdist
						Local tmp:TLink = Game.Objects.AddLast(New TPortal.Create(Game,data[0], data[1],Data[2],data[4],data[5],data[6]))
						Game.RebuildRay
						tmp.remove
						data[7] = 1
						dont = True
					EndIf
				EndIf
				If Not dont And data[7]
					Game.RebuildRay
					data[7] = 0
				EndIf
			Case Mirror
				If Mirrors = 0 
					Selected = Null
					Return
				EndIf
				If data = Null data = New Float[4]
				Data[0] :+ zspeed*15
				Local l:Byte = False
				If Not data[1]
					If mh data[1] = 1
					data[2] = MouseX() - Game.Map.ScrollX
					data[3] = MouseY() - Game.Map.ScrollY
				ElseIf GetDistance(data[2],data[3],MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY)>32
					data[0] = GetAngle(data[2],data[3],MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY)
					l = True
				EndIf
				
				If Not MouseDown(1) And data[1]
					Game.Objects.addlast New TMirror.Create(Game,data[2], data[3],Data[0])
					Game.RebuildRay()
					Selected = Null
					data = Null
					Mirrors:-1
				Else
					Local tmp:TLink = Game.Objects.AddLast(New TMirror.Create(Game,data[2], data[3],Data[0]))
					Game.RebuildRay
					tmp.remove
				EndIf
			Default
				data = Null
				If Mh
					For Local Poc:TPocketLight=EachIn Game.Objects
						If getdistance(Poc.X,Poc.Y,MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY) <32
							TurnPoc = Poc
							Mh = False
						EndIf
					Next
					If mh
						For Local d:Tdiskokugel=EachIn Game.Objects
							If getdistance(d.X,d.Y,MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY) <32
								d.Turn = 1 - d.Turn
								Mh = False
							EndIf
						Next
					EndIf
				Else
					If TurnPoc And MouseDown(1)
						Game.Map.ScrollX = Game.OSX
						Game.map.ScrollY = Game.OSY
						Local angl:Float = GetAngle(TurnPoc.X,TurnPoc.Y,MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY)+180
						For Local Poc:TPocketLight=EachIn Game.Objects
							If Poc <> TurnPoc
								Poc.SetAngle (Poc.GetAngle() - TurnPoc.GetAngle()) + Angl
							EndIf
						Next
						TurnPoc.SetAngle Angl
					Else
						TurnPoc = Null
					EndIf
				EndIf
		EndSelect
	EndMethod
	Field state:Float = 0
	Method Render()
		
		Local i:Int = 0
		SetColor 200,0,0
		If Hover = 0 SetAlpha .2 Else SetAlpha .6
		DrawRect -40+Hover,32-8,64,128+16
		SetAlpha 1
		SetColor 255,255,255
		If Hover = 0 SetAlpha .6
		For Local Img:TImage = EachIn [Portal, Mirror]
			If RectsOverlap(-40+Hover,32+i,64,64,MouseX(),MouseY(),1,1)
				SetColor 0,0,255
				DrawRect -40+Hover,32+i,64,64
				SetColor 255,255,255
			EndIf
			DrawImage Img,-40+Hover,32+i
			Local txt:String = mirrors
			If Img = Portal txt = portals
			DrawText txt,-40+Hover+54,32+i+50 
			i:+ 70
		Next
		SetAlpha .6
		SetColor 255,0,0
		If RectsOverlap(GraphicsWidth()-30-Hover2,20-5,200,TextHeight("")+10,MouseX(),MouseY(),1,1)
			SetColor 0,0,255
		EndIf
		
		DrawRect GraphicsWidth()-30-Hover2,20-5,200,TextHeight("")+10
		SetAlpha 1
		SetColor 255,255,255
		DrawText "Neustart",GraphicsWidth()-20-Hover2,20
		SetColor 255,255,255
		Select Selected
			Case Portal
				DrawInfo "Platzieren Sie zwei Portale",0,0
				If data[4] <> -1 Or data[5]<>-1 Or data[6]<>-1
					SetRotation data[6]
					SetColor 255,0,0
					DrawImage RealPortal,data[4]+16+Game.Map.ScrollX,data[5]+16+Game.Map.ScrollY
					SetColor 255,255,255
					SetRotation 0
					
					If data[4] <> -1 Or data[5]<>-1 Or data[6]<>-1
						Local dist:Float = getdistance(data[4],data[5],data[0],data[1])
						If dist < MAXDIST SetColor 0,255,0 Else SetColor 255,0,0
						DrawLine data[4]+16+Game.Map.ScrollX+Cos(data[6])*8,data[5]+16+Game.Map.ScrollY+Sin(data[6])*8,data[0]+16+Game.Map.ScrollX+Cos(data[2])*8,data[1]+16+Game.Map.ScrollY+Sin(data[2])*8
						SetColor 255,255,255
					EndIf
				EndIf
				If data[3]
					SetRotation data[2]
					If data[4] <> -1 Or data[5]<>-1 Or data[6]<>-1
						SetColor 0,255,0
					Else
						SetColor 255,0,0
					EndIf
					DrawImage RealPortal,data[0]+16+Game.Map.ScrollX,data[1]+16+Game.Map.ScrollY
					SetRotation 0
					SetColor 255,255,255
				EndIf
				
			Case Mirror
				DrawInfo "Zum drehen, Mausrad verwenden oder ziehen.",0,0
				SetRotation data[0]
				DrawImage RealMirror,data[2]+Game.Map.ScrollX, data[3]+Game.Map.ScrollY
				SetRotation 0
			Default
				For Local d:Tdiskokugel=EachIn Game.Objects
					If getdistance(d.X,d.Y,MouseX() - Game.Map.ScrollX,MouseY() - Game.Map.ScrollY) <32
						DrawInfo "Zum stoppen der Drehung, Mausklick.",0,0
						Exit
					EndIf
				Next		
		EndSelect
	EndMethod
	
	Function DrawInfo(Text:String, X:Int, Y:Int)
		Local sx:Float,sy:Float
		GetScale sx, sy
		SetColor 255,0,0
		SetAlpha .4+(1-GetAlpha())
		DrawRect X,Y,TextWidth(Text)+20,TextHeight("")/sy+20
		SetAlpha 1
		SetColor 255,255,255
		DrawText Text,X+10,Y+10
	EndFunction
	
	Method GetX:Int(i:Int)
		Return 10*i + 64*(i-1)
	EndMethod
	
	Method Create:THUD(Game:TGameState)
		Self.Game = Game
		
		
		Return Self
	EndMethod
EndType

Type TRay
	Const MAXRAYLENGTH:Int = 16 'Die lnge eines strahls (kann auch kleiner sein)
	Field Strength:Int
	Field MaxStrength:Int
	Field X:Float, Y:Float, Angle:Float
	Field ToX:Float, ToY:Float
	Field Parent:TRay
	Field Child:TRay
	Field Game:TGameState
	Field TmpX:Float,TmpY:Float
	Method Update()
	EndMethod
	
	Method Render()
		If Parent = Null
			SetColor 255,255,0
		EndIf
		SetAlpha Float(Strength)/Float(MaxStrength)
		
		DrawQuad(x + tmpx*4,y + tmpy*4,x - tmpx*4,y-tmpy*4,tox+tmpx*4,toy + tmpy*4,tox - tmpx*4,toy - tmpy*4)
		
		If Child Child.Render()
		If Parent = Null
			SetAlpha 1
			SetColor 255,255,255
		EndIf
	EndMethod
	
	Method Create:TRay(Game:TGameState, Parent:TRay, X:Float, Y:Float, Angle:Float, Strength:Int, MaxStrength:Int = -1)
		Self.X = X
		Self.Y = Y
		Self.Game = Game
		Self.Strength = Strength
		If MaxStrength = -1
			Self.MaxStrength = Strength
		Else
			Self.MaxStrength = MaxStrength
		EndIf
		Self.Parent = Parent
		
		SetAngle(Angle,True)
		Return Self
	EndMethod
	
	Method GetAngle:Float()
		Return Angle
	EndMethod
	
	Method SetAngle(Angle:Float, NotCheck:Byte = False)
		If Self.Angle <> Angle Or NotCheck
			Self.Angle = Angle
			Self.ToX = X + Cos(Angle)*MaxRAYLENGTH
			Self.ToY = Y + Sin(Angle)*MaxRayLength
			
			TmpX = ToY - Y 'normalvektor
			TmpY = -(ToX - X)
			Local Length:Float = Sqr(tmpx*tmpx + tmpy*tmpy)
			tmpx = tmpx/length
			tmpy = tmpy/length
			If NotCheck RebuildChild()
		EndIf
	EndMethod
	
	Method RebuildChild()	
		If Game.IsCollision(Self.X,Self.Y)
			Self.X = Game.LastX
			Self.Y = Game.LastY
			CHild = Null
		Else
			For Local Obj:TGameObject = EachIn Game.Objects
				Obj.OnRebuild(Self)
			Next
			
			If Self.Strength <= 1 Return
			Local tmp:Float[] = game.map.getcollisioninfo(Self.X,Self.Y,Self.ToX,Self.ToY)
			For Local i:Int = 0 To 24
				If Not tmp Exit
				If i > 16 Child = Null
				If tmp[3] = 1 
					Self.Strength = 0
					Child = Null
				EndIf
				X = (X + tmp[0]*2)/3
				Y = (Y + tmp[1]*2)/3
				If Parent
					Parent.ToX = X
					Parent.ToY = Y
				EndIf
				SetAngle((2*tmp[2] Mod 360)- GetAngle())
				
				tmp = game.map.getcollisioninfo(Self.X,Self.Y,Self.ToX,Self.ToY)
			Next
			
			If Self.Strength > 1
				Local add:Int = 0
				If Game.Map.IsCollision(Self.X,Self.Y) add = 180
				Self.Child = New TRay.Create(Game, Self, Self.ToX,Self.ToY,Self.Angle+add,Self.Strength - 1,Self.MaxStrength)
			EndIf
		EndIf
	EndMethod
EndType

Type TGameMap
	Field Map:Byte[,]
	Field Width:Int, Height:Int
	Field ScrollX:Int, ScrollY:Int
	
	Method Load:TGameMap( File:Int)
		Local strm:TStream = ReadFile("level/map"+file)
		width = strm.ReadInt()
		height = strm.ReadInt()
		map = New Byte[width, height]
		For Local x:Int = 0 Until width
			For Local y:Int = 0 Until height
				map[x,y] = strm.ReadByte() - 1
			Next
		Next
		CloseStream strm
		Return Self
	EndMethod
	
	Method Update()
		
	EndMethod
	
	Method Render()
		For Local x:Int = 0 Until Width
			For Local y:Int = 0 Until Height
				If IsCollision(X*32.0,Y*32.0) 
					Local i:Int = 2
					If map[x,y]=1 i = 1
					DrawImage Tileset, X*32,y*32, i
				EndIf
			Next
		Next
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		X = Floor(X/32.0)
		Y = Floor(Y/32.0)
		If X>=0 And Y>=0 And X<Width And Y<Height
			Return Map[X,Y] <> 255
		EndIf
	EndMethod
	
	Rem
		Gibt die Kollisionsinfos zurck. 0,1=Position der kollision, 2=einfallswinkel
	EndRem
	Method GetCollisionInfo:Float[](X1:Float,Y1:Float,X2:Float,Y2:Float)
		'in 5 Schritten abtasten
		Local stepsize:Float = GetDistance(X1,Y1,X2,Y2)
		Local StepX:Float = (X2 - X1)/stepsize, StepY:Float = (Y2 - Y1)/stepsize
		Local X:Float = X1, Y:Float = Y1
		For Local i:Float = 0 Until stepsize Step .75
			Local tmp:Float[] = GetCollisionInfoTile(X1,Y1,X2,Y2,Floor(X/32.0),Floor(Y/32.0))
			If tmp Return tmp
			X:+ StepX
			Y:+ StepY
		Next
	EndMethod
	Method GetCollisionInfoTile:Float[](X1:Float,Y1:Float,X2:Float,Y2:Float,X:Int,Y:Int)
		If X>=0 And Y>= 0 And X<Width And Y<Height And Map[X,Y] <> 255 And (IsCollision(X1,Y1) Or IsCollision(X2,Y2))
			Local Colli:Byte = True
			Local angle:Float

			If ((Y > 0) And Map[X,Y-1]=255) And LinesIntersect(X1,Y1,X2,Y2, X*32.0,Y*32.0,X*32 + 32, Y*32)
				angle = 180
			ElseIf (Y < Height-1 And Map[X,Y+1]=255) And LinesIntersect(X1,Y1,X2,Y2, X*32.0,Y*32.0+32,X*32 + 32, Y*32+32)
				angle = 0
			ElseIf ((X > 0) And Map[X-1,Y]=255) And LinesIntersect(X1,Y1,X2,Y2, X*32.0,Y*32.0,X*32, Y*32+32)
				angle = 90
			ElseIf (X < Width-1 And Map[X+1,Y]=255) And LinesIntersect(X1,Y1,X2,Y2, X*32.0+32,Y*32.0,X*32+32, Y*32+32)
				angle = 270
			Else
				Colli = False
			EndIf
			If Colli
				Return [intersection_x, intersection_y, angle, Float(map[X,Y])]
			EndIf
		EndIf
	EndMethod
EndType

Type TGameObject Abstract
	Field X:Float, Y:Float
	Field Game:TGameState
	Method IsCollision:Byte(X:Float, y:Float) Abstract
	Method Update() Abstract
	Method Render() Abstract
	
	Method OnRebuild(Ray:TRay)
	EndMethod
	Method Rebuild()
	EndMethod
	
	
	Method SetPosition(X:Float, Y:Float)
		Self.X = X
		Self.Y = Y
	EndMethod
	Method GetX:Float()
		Return X
	EndMethod
	Method GetY:Float()
		Return Y
	EndMethod
	Method InitRebuild()
	EndMethod
EndType

Type TPocketLight Extends TGameObject
	Global MyStrength:Int = 128
	Field Ray:TRay
	Field Angle:Float
	Field Strength:Int
	Method Update()
	EndMethod
	
	Method Render()
		Ray.Render()
		SetRotation Ray.Angle
		DrawImage PocketLight,X,Y
		SetRotation 0
	EndMethod
	
	Method Rebuild()
		If Ray Self.Angle = Ray.Angle
		Ray = New TRay.Create(Game,Null,X,Y,Angle,Strength)
		Ray.SetAngle(Ray.GetAngle(),True)		
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		Return False
	EndMethod
	Method GetAngle:Float()
		Return Ray.Angle
	EndMethod
	Method SetAngle(Angle:Float)
		Game.InitRebuild
		Ray.SetAngle(Angle,True)
	EndMethod
	
	Method Create:TPocketLight(Game:TGameState, X:Float, Y:Float, Angle:Float)
		SetPosition(X,Y)
		Self.Game = Game
		Self.Angle = Angle
		Strength = MyStrength
		Rebuild
		
		
		Return Self
	EndMethod
EndType

Type TButton Extends TGameObject
	Field IsActi:Int = 0

	Method Update()
		
	EndMethod
	
	Method Render()
		DrawImage Button, X,Y
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		If GetDIstance(X,Y,Self.X,Self.Y)<14
			IsActi = 1
			Return True
		Else
			Return False
		EndIf
	EndMethod
	
	Method Create:TButton(Game:TGameState, X:Float, Y:Float)
		SetPosition(X,Y)
		Self.Game = Game
		
		Return Self
	EndMethod
	
	Method InitRebuild()
		IsActi = 0
	EndMethod
EndType

Type TBlackhole Extends TGameObject
	Field rot:Int = Rand(1,350)
	
	Method Update()
		rot = (rot+12) Mod 360
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		Return GetDIstance(X,Y,Self.X,Self.Y)<16
	EndMethod
	
	Method Render()
		SetRotation rot
		DrawImage BlackHole, X,Y
		SetRotation 0
	EndMethod
	
	Method Create:TBlackHole(Game:TGameState, X:Float, Y:Float)
		SetPosition(X,Y)
		Self.Game = Game
		
		Return Self
	EndMethod
	
	
	Method OnRebuild(Ray:TRay)
		'schauen wie weit
		If GetDistance(X,Y,Ray.X,Ray.Y) <256 And Ray.Parent
			Local OldX:Float=Ray.ToX, OldY:Float=Ray.ToY, OldAngle:Float = Ray.Angle
			Local Length:Float = GetDistance(Ray.X,Ray.Y,Ray.ToX,Ray.ToY)
			Local Ang:Float = GetAngle(Ray.X,Ray.Y,X,Y)
			Local AngTo:Float = GetAngle(Ray.X,Ray.Y,Ray.ToX,Ray.ToY)
			Local Dist:Float = GetDistance(Ray.X,Ray.Y,X,Y)
			
			
			Local angi:Float = Abs(AngTo)
			
			
			If Ray.Y > Y
				Ray.Angle :+ (256.0/Dist)*.75
			Else
				Ray.Angle :- (256.0/Dist)*.75
			EndIf
			
			Length = 8
			Ray.ToX = Ray.X + Cos(Ray.Angle) * Length
			Ray.ToY = Ray.Y + Sin(Ray.Angle) * Length
			
			If Game.IsCollision(Ray.ToX,Ray.ToY)
				Ray.Angle = OldAngle
				Ray.ToX = OldX
				Ray.ToY = OldY
			EndIf
		EndIf
	EndMethod
	
	
EndType

Type TPortal Extends TGameObject
	Field Angle:Float
	Field R:TRay
	Field X2:Float,Y2:Float, Angle2:Float
	
	Method Update()
	EndMethod
	
	Method Render()
		SetRotation Angle2
		SetColor 255,0,0
		DrawImage RealPortal,X2+16,Y2+16
		SetRotation Angle
		SetColor 0,255,0
		DrawImage RealPortal,X+16,Y+16
		SetRotation 0
		SetColor 255,255,255
	EndMethod
	
	Method Create:TPortal(Game:TGameState, X1:Float, Y1:Float,Angle1:Int, X2:Float, Y2:Float,Angle2:Float)
		SetPosition(X1,Y1)
		Self.Game = Game
		Self.Angle = Angle1
		Self.Angle2 = Angle2
		Self.X2 = X2
		Self.Y2 = Y2
		
		Return Self
	EndMethod 
	
	Method IsCollision:Byte(X:Float,Y:Float)
		Return 0
	EndMethod

	Method OnRebuild(Ray:TRay)
		Local TmpX1:Float, TmpY1:Float
		Local TmpX2:Float, TmpY2:Float
		TmpX1 = X+16+Cos(Angle+90)*-16 + Cos(Angle)*16
		TmpY1 = Y+16+Sin(Angle+90)*-16 + Sin(Angle)*16
		TmpX2 = X+16+Cos(Angle+90)* 16 + Cos(Angle)*16
		TmpY2 = Y+16+Sin(angle+90)* 16 + Sin(Angle)*16
		
		If LinesIntersect(Ray.X,Ray.Y,Ray.ToX+Cos(Ray.Angle)*8,Ray.ToY+Sin(Ray.Angle)*8,tmpx1,tmpy1,tmpx2,tmpy2)
			Local tmpAngle:Float = Angle2 - (Angle - Ray.Angle)
			While tmpangle < 0
				tmpangle = 360 + tmpangle
			Wend
			tmpangle = tmpangle Mod 360
			tmpangle:+180
			Ray.ToX = X+16 + Cos(Angle)*16+Cos(tmpangle)*8
			Ray.ToY = Y+16 + Sin(Angle)*16+Sin(tmpangle)*8
			Ray.Child = New TRay.Create(Game, Ray, X2+16 + Cos(Angle2)*16+Cos(tmpangle)*8,Y2+16 + Sin(Angle2)*16+Sin(tmpangle)*8,tmpangle,Ray.Strength-1,Ray.MaxStrength)
			Ray.Strength = 0
		EndIf
		
		TmpX1 = X2+16+Cos(Angle2+90)*-16 + Cos(Angle2)*16
		TmpY1 = Y2+16+Sin(Angle2+90)*-16 + Sin(Angle2)*16
		TmpX2 = X2+16+Cos(Angle2+90)* 16 + Cos(Angle2)*16
		TmpY2 = Y2+16+Sin(angle2+90)* 16 + Sin(Angle2)*16
		
		If LinesIntersect(Ray.X,Ray.Y,Ray.ToX+Cos(Ray.Angle)*8,Ray.ToY+Sin(Ray.Angle)*8,tmpx1,tmpy1,tmpx2,tmpy2)
			Local tmpAngle:Float = Angle - (Angle2 - Ray.Angle)
			While tmpangle < 0
				tmpangle = 360 + tmpangle
			Wend
			tmpangle = tmpangle Mod 360
			tmpangle:+180
			Ray.ToX = X2+16 + Cos(Angle2)*16+Cos(tmpangle)*8
			Ray.ToY = Y2+16 + Sin(Angle2)*16+Sin(tmpangle)*8
			Ray.Child = New TRay.Create(Game, Ray, X+16 + Cos(Angle)*16+Cos(tmpangle)*8,Y+16 + Sin(Angle)*16+Sin(tmpangle)*8,tmpangle,Ray.Strength-1,Ray.MaxStrength)
			Ray.Strength = 0
		EndIf
	EndMethod
EndType

Type TMirror Extends TGameObject
	Field Angle:Float
	
	Method Update()
	
	EndMethod
	
	Method Render()
		SetRotation Angle-90
		DrawImage RealMirror,X,Y
		SetRotation 0
	EndMethod
	
	Method Create:TMirror(Game:TGameState, X:Float,Y:Float,Angle:Float)
		SetPosition(X,Y)
		Self.Angle = Angle+90
		Self.Game = Game
		
		Return Self
	EndMethod
	
	Method OnRebuild(Ray:TRay)
		If LinesIntersect(Ray.X,Ray.Y,Ray.ToX,Ray.ToY, Self.X - Cos(Angle)*16,Self.Y - Sin(Angle)*16,Self.X + Cos(Angle)*16, Self.Y + Sin(Angle)*16)
			Ray.X = (Ray.X + Intersection_x*2)/3.0
			Ray.Y = (Ray.Y + intersection_y*2)/3.0
			If (Ray.Parent)
				Ray.Parent.ToX = Ray.X
				Ray.Parent.ToY = Ray.Y
			EndIf
			Ray.SetAngle(2*Angle - Ray.GetAngle())
		EndIf
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		Return False
	EndMethod
EndType

Type TDiskokugel Extends TGameObject
	Field Angle:Float = 105
	Field Rays:TList=New TList
	Field MyRay:TRay
	Field Turn:Byte = True
	Method Update()
		If Turn
			Angle:+.75
			
			If MyRay
				Game.RebuildRay
			EndIf
		EndIf
	EndMethod
	
	Method Render()
		SetColor 255,255,0
		For Local R:TRay=EachIn Rays
			R.Render
		Next
		SetColor 255,255,255
		SetAlpha 1
		SetColor 255,255,0
		SetBlend Lightblend
		SetRotation Angle
		SetScale 2,2
		DrawImage Disko,X,Y
		SetScale 1,1
		SetBlend ALPHABLEND
		SetAlpha .2
		SetColor 255,255,255
		DrawImage Disko,X,Y
		SetAlpha 1
		SetRotation 0
	EndMethod
	
	Method Create:TDiskokugel(Game:TGameState, X:Float, Y:Float)
		SetPosition(X,Y)
		Self.Game = Game
		
		Return Self
	EndMethod
	
	Method OnRebuild(Ray:TRay)
		If GetDistance(Ray.X,Ray.Y,X,Y) < 26
			If Rays.Count() = 0 And Ray.Strength > 4
				MyRay = Ray
				Rays.Clear
				For Local i:Int = 0 To 360 Step 36
					Rays.AddLast New TRay.Create(Game, Ray, X+Cos(i+angle+(Ray.Angle-92))*28,Y+Sin(i+angle+(Ray.Angle-92))*28,i+angle+(Ray.Angle-92),Ray.Strength/2 - 5,Ray.MaxStrength)
				Next
				
			EndIf
			Ray.Strength = 0
		EndIf
	EndMethod
	
	Method InitRebuild()
		Rays.Clear
	EndMethod
	
	Method IsCollision:Byte(X:Float, Y:Float)
		Return False
	EndMethod
EndType



'TODO: Diese funktion mit OpenGL Calls implementieren.
Function DrawQuad(X1:Float,y1:Float,x2:Float,y2:Float, x3:Float,y3:Float,x4:Float, y4:Float)
	Local p:Float[] = [x1,y1,x2,y2,x3,y3]
	DrawPoly p
	p = [x2,y2,x3,y3,x4,y4]
	DrawPoly p
EndFunction
Global intersection_x:Float,intersection_y:Float
Function LinesIntersect:Byte(ax:Float, ay:Float, bx:Float, by:Float, cx:Float, cy:Float, dx:Float, dy:Float) 
'DrawLine ax,ay,bx,by
'DrawLine cx,cy,dx,dy
   Local rn:Float = (ay:Float-cy:Float)*(dx:Float-cx:Float) - (ax:Float-cx:Float)*(dy:Float-cy:Float) 
   Local rd:Float = (bx:Float-ax:Float)*(dy:Float-cy:Float) - (by:Float-ay:Float)*(dx:Float-cx:Float) 
   If rd:Float = 0 
      Return False 
   Else 
      Local sn:Float = (ay:Float-cy:Float)*(bx:Float-ax:Float) - (ax:Float-cx:Float)*(by:Float-ay:Float) 
      Local intersection_ab:Float = rn:Float / rd:Float 
      Local intersection_cd:Float = sn:Float / rd:Float 
      intersection_x:Float  = ax:Float + intersection_ab:Float*(bx:Float-ax:Float) 
      intersection_y:Float  = ay:Float + intersection_ab:Float*(by:Float-ay:Float) 
      If intersection_ab:Float>0 And intersection_ab:Float<1 And intersection_cd:Float>0 And intersection_cd:Float<1 Then Return True 
   EndIf 
End Function

Function getdistance:Float(x1:Float,y1:Float,x2:Float,y2:Float)
	Return Sqr((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
End Function

Function getangle:Float(x1:Float,y1:Float,x2:Float,y2:Float)
	Return (450.0-ATan2(x1-x2,y1-y2)) Mod 360.0
End Function

Function rectsoverlap:Int(X1:Int, Y1:Int, Breite1:Int, Hoehe1:Int, X2:Int, Y2:Int, Breite2:Int, Hoehe2:Int)
	If x1 <= (x2 + breite2) And y1 <= y2 + hoehe2 And (x1 + breite1) >= x2 And (y1 + hoehe1) >= y2  Return True
	Return False
End Function
