Global xmax=800
Global ymax=600
Global fullscreen=False
Global musicon=True
Global timer
Global showpos%=False

ChangeDir "data"
Global click
Global font
Global mouse
Global cmdImg
restart

runMenu

Function restart()
	EndGraphics
	For b.TButton=Each TButton
		Delete b
	Next
	Graphics3D xmax,ymax,32,1+(fullscreen=False)
	timer=CreateTimer(60)
	click=LoadSound("click.ogg")
	font=LoadFont("Century Gothic",18)
	mouse=LoadImage("mouse.png")
	MaskImage mouse,255,0,255
	SeedRnd MilliSecs()
	SetFont font
End Function

Function showLogo()
	Cls
	img=LoadImage("logo.png")
	MaskImage img,255,0,255
	DrawImage img,xmax/2-ImageWidth(img)/2,ymax/2-ImageHeight(img)/2
	bfont=LoadFont("Century Gothic",40)
	SetFont bfont
	txt$=getnonsense()
	Color 255,255,255
	Text xmax/2-StringWidth(txt)/2,ymax-StringHeight(txt)-20,txt
	SetFont font
	Flip
	FreeImage img
End Function

Function runMenu(showSettings%=False)
	music=LoadSound("menu.ogg")
	LoopSound music
	channel=PlaySound(music)
	bg=LoadImage("bg.png")
	cmdImg=LoadAnimImage("button.png",232,50,0,2)
	cmdPlay.TButton=createbutton("Spielen",40,ymax-270,cmdImg)
	cmdSettings.TButton=createbutton("Einstellungen",40,ymax-210,cmdImg)
	cmdCredits.TButton=createbutton("Credits",40,ymax-150,cmdImg)
	cmdExit.TButton=createbutton("Beenden",40,ymax-90,cmdImg)
	If showSettings Then runSettings bg,cmdImg,channel
	While Not KeyHit(1)
		Cls
		If cmdPlay\hit Then
			showLogo
			PauseChannel channel
			runGame 0
			If musicon Then ResumeChannel channel
		ElseIf cmdSettings\hit Then
			runSettings bg,cmdImg,channel
		ElseIf cmdCredits\hit Then
			runCredits bg,cmdImg
		ElseIf cmdExit\hit Then
			Exit
		End If
		DrawImage bg,0,0
		updatebuttons MouseHit(1)
		If fullscreen DrawImage mouse,MouseX(),MouseY()
		Flip
		WaitTimer timer
	Wend
End Function

Function runSettings(bg%,cmdImg%,channel%)
	settingsImg=LoadImage("settings.png")
	MaskImage settingsImg,255,0,255
	cmdBack.TButton=createButton("Zurck",xmax/2-ImageWidth(cmdImg)/2,ymax-100,cmdImg)
	fbtxt$=""
	If fullscreen Then fbtxt="Fenstermodus" Else fbtxt="Vollbild"
	cmdFullscreen.TButton=createButton(fbtxt,xmax/2-ImageWidth(settingsImg)/2+10,ymax/2-ImageHeight(settingsImg)/2+40,cmdImg)
	cmdMusic.TButton=createButton("",xmax/2-ImageWidth(settingsImg)/2+10,ymax/2-ImageHeight(settingsImg)/2+ImageHeight(cmdImg)+50,cmdImg)
	reset%=False
	While Not (KeyHit(1) Or cmdBack\hit)
		Cls
		
		If musicon Then fbtxt="Musik ausschalten" Else fbtxt="Musik einschalten"
		cmdMusic\txt=fbtxt
		
		DrawImage bg,0,0
		DrawImage settingsImg,xmax/2-ImageWidth(settingsImg)/2,ymax/2-ImageHeight(settingsImg)/2
		mh=MouseHit(1)
		updatebutton cmdBack,mh
		updatebutton cmdFullscreen,mh
		updatebutton cmdMusic,mh
		If cmdFullscreen\hit Then
			fullscreen=1-fullscreen
			reset=True
			Exit
		End If
		If cmdMusic\hit Then
			musicon=1-musicon
			If musicon Then
				ResumeChannel channel
			Else
				PauseChannel channel
			End If
		End If
		If fullscreen DrawImage mouse,MouseX(),MouseY()
		Flip
		WaitTimer timer
	Wend
	FreeImage settingsImg
	Delete cmdBack
	Delete cmdFullscreen
	Delete cmdMusic
	If reset Then
		StopChannel channel
		restart
		runMenu(True)
		End
	EndIf
End Function

Function runCredits(bg%,cmdImg%)
	creditsImg=LoadImage("credits.png")
	MaskImage creditsImg,255,0,255
	cmdBack.TButton=createButton("Zurck",xmax/2-ImageWidth(cmdImg)/2,ymax-100,cmdImg)
	While Not (KeyHit(1) Or cmdBack\hit)
		Cls
		DrawImage bg,0,0
		DrawImage creditsImg,xmax/2-ImageWidth(creditsImg)/2,ymax/2-ImageHeight(creditsImg)/2
		updatebutton cmdBack,MouseHit(1)
		If fullscreen DrawImage mouse,MouseX(),MouseY()
		Flip
		WaitTimer timer
	Wend
	FreeImage creditsImg
	Delete cmdBack
End Function

Function drawButton(b.TButton)
	DrawImage b\img,b\x,b\y,b\hover
	Color 100,100,100
	Text b\x+ImageWidth(b\img)/2-StringWidth(b\txt)/2,b\y+ImageHeight(b\img)/2-StringHeight(b\txt)/2,b\txt
End Function

Function mouseOverButton(b.TButton)
	mx=MouseX()
	my=MouseY()
	Return(mx>=b\x And my>=b\y And mx<=b\x+ImageWidth(b\img) And my<=b\y+ImageHeight(b\img))
End Function

Function updateButtons(hit%)
	For b.tbutton=Each tbutton
		updateButton b,hit
	Next
End Function
Function updateButton(b.TButton,hit%)
	b\hover=mouseOverButton(b)
	b\hit=(b\hover And hit)
	If b\hit Then
		PlaySound click
	EndIf
	drawButton b
End Function

Function createButton.TButton(txt$,x%,y%,img%)
	b.TButton=New TButton
	b\txt=txt
	b\x=x
	b\y=y
	b\img=img
	Return b
End Function

Type TButton
	Field txt$
	Field x%
	Field y%
	Field img%
	Field hover%
	Field hit%
End Type

Function runGame(lvl%)
	HidePointer
	stream=ReadFile("voice"+lvl+".txt")
	title$=ReadLine(stream)
	While Not Eof(stream)
		v.TVoice=New TVoice
		v\sound=LoadSound(ReadLine(stream))
		v\posx=Float(ReadLine(stream))
		v\posy=Float(ReadLine(stream))
		v\posz=Float(ReadLine(stream))
	Wend
	winVoice.TVoice=Last TVoice
	CloseFile stream
	
	music=LoadSound("game.ogg")
	LoopSound music
	If musicon Then ChannelVolume PlaySound(music),0.5
	
	foot=CreateSphere(8)
	EntityAlpha foot,0
	cam=CreateCamera(foot)
	PositionEntity cam,0,1.5,0
	CameraRange cam,0.1,1000
	footCol=CreateCube(foot)
	EntityAlpha footCol,0
	ScaleEntity footCol,0.25,0.75,0.25
	footP=CreateSphere(8,foot)
	EntityAlpha(footP,0)
	ScaleEntity footP,1.1,1.1,1.1
	weapon=LoadMesh("weapon.3ds",cam)
	MoveEntity weapon,0.25,-0.25,0
	
	light=CreateLight(3.5)
	LightRange light,10
	AmbientLight 160,160,160
	
	world=LoadMesh("map"+lvl+".3ds")
	EntityPickMode world,2
	
	mask=LoadMesh("mask"+lvl+".3ds")
	EntityAlpha mask,0
	EntityPickMode mask,2
	
	portalcam=CreateCamera()
	CameraClsColor portalcam,100,100,100
	CameraRange portalcam,0.1,1000
	HideEntity portalcam
	
	p1on=False
	portal1=createPortalSurface(1,1.5)
	EntityFX portal1,1
	portal1tex=LoadTexture("empty1.png",256)
	HideEntity portal1
	EntityTexture portal1,portal1tex
	portal1col=CreateSphere(8,portal1)
	ScaleEntity portal1col,0.5,1,0.5
	EntityAlpha portal1col,0
	portal1sp=LoadSprite("port.png",0,portal1)
	SpriteViewMode portal1sp,2
	ScaleSprite portal1sp,1.1,1.6
	MoveEntity portal1sp,0,0,-0.01
	EntityColor portal1sp,0,0,255
	p1l=CreateLight(2,portal1)
	LightColor p1l,0,0,255
	LightRange p1l,3
	
	p2on=False
	portal2=createPortalSurface(1,1.5)
	EntityFX portal2,1
	portal2tex=LoadTexture("empty2.png",256)
	HideEntity portal2
	EntityTexture portal2,portal2tex
	portal2col=CreateSphere(8,portal2)
	ScaleEntity portal2col,0.5,1,0.5
	EntityAlpha portal2col,0
	portal2sp=LoadSprite("port.png",0,portal2)
	SpriteViewMode portal2sp,2
	ScaleSprite portal2sp,1.1,1.6
	MoveEntity portal2sp,0,0,-0.01
	EntityColor portal2sp,255,0,0
	p2l=CreateLight(2,portal2)
	LightColor p2l,255,0,0
	LightRange p2l,3
	
	door=LoadMesh("door"+lvl+".3ds")
	EntityBlend door,3
	EntityPickMode door,2
	EntityFX door,1
	
	water=LoadMesh("water"+lvl+".3ds")
	EntityAlpha water,0.7
	
	EntityType foot,1
	EntityType world,2,True
	EntityType portal1col,3
	EntityType portal2col,3
	EntityType door,4
	EntityType footCol,5
	EntityType footP,6
	EntityType cam,7
	EntityType water,8
	Collisions 1,2,2,2
	Collisions 5,2,2,2
	Collisions 5,4,2,2
	Collisions 6,3,2,2
	Collisions 7,2,2,2
	Collisions 1,8,2,2
	
	printText(title,255,255,255,0,0,0,cam,False)
	
	MouseXSpeed
	MouseYSpeed
	MoveMouse xmax/2,ymax/2
	xSpeed#=0
	ySpeed#=0
	zSpeed#=0
	lastCol%=0
	channel%=0
	won%=False
	restart%=False
	nextlevel%=False
	While(True)
		x#=EntityX(foot)
		y#=EntityY(foot)
		z#=EntityZ(foot)
		If channel=0 Or ChannelPlaying(channel)=0 Then
			For v.TVoice=Each TVoice
				If ((x-v\posx)*(x-v\posx)+(y-v\posy)*(y-v\posy)+(z-v\posz)*(z-v\posz))<4*4 Then
					If v=winVoice Then
						won=True
					End If
					channel=PlaySound(v\sound)
					Delete v
					Exit
				EndIf
			Next
		End If
		
		a#=MilliSecs()/10.0
		PositionEntity water,0.1*Cos(a),0.1*Cos(0.5*a),0.1*Sin(a)
		
		entity=EntityCollided(footP,3)
		If p1on And p2on And lastCol=0 And (entity=portal1col Or entity=portal2col)=True Then
			If entity=portal1col Then
				HideEntity foot
				PositionEntity foot,EntityX(portal2)+Sin(EntityYaw(portal2))*Cos(EntityPitch(portal2)),EntityY(portal2)+Sin(EntityPitch(portal2))*(1+speedy),EntityZ(portal2)+Cos(EntityYaw(portal2))*Cos(EntityPitch(portal2))
				RotateEntity foot,0,EntityYaw(portal2),0
				TurnEntity foot,0,180,0
				TurnEntity cam,-EntityPitch(portal2)+EntityPitch(portal1),0,0
				ShowEntity foot
				lastCol=entity
				xSpeed=-Sin(EntityYaw(portal2))*Cos(EntityPitch(portal2))*ySpeed
				zSpeed=-Cos(EntityYaw(portal2))*Cos(EntityPitch(portal2))*ySpeed
				ySpeed=-Sin(EntityPitch(portal2))*(ySpeed)
			ElseIf entity=portal2col Then
				HideEntity foot
				PositionEntity foot,EntityX(portal1)+Sin(EntityYaw(portal1))*Cos(EntityPitch(portal1)),EntityY(portal1)+Sin(EntityPitch(portal1))*(1+speedy),EntityZ(portal1)+Cos(EntityYaw(portal1))*Cos(EntityPitch(portal1))
				RotateEntity foot,0,EntityYaw(portal1),0
				TurnEntity foot,0,180,0
				TurnEntity cam,-EntityPitch(portal1)+EntityPitch(portal2),0,0
				ShowEntity foot
				lastCol=entity
				xSpeed=-Sin(EntityYaw(portal1))*Cos(EntityPitch(portal1))*ySpeed
				zSpeed=-Cos(EntityYaw(portal1))*Cos(EntityPitch(portal1))*ySpeed
				ySpeed=-Sin(EntityPitch(portal1))*(ySpeed)
			Else
				lastCol=0
			End If
		ElseIf (entity=portal1col Or entity=portal2col)=False Then
			lastCol=0
		End If
		If EntityCollided(footCol,4)=door Then
			HideEntity portal1
			HideEntity portal2
			p1on=0
			p2on=0
		EndIf
		
		aX#=EntityX(foot)
		aY#=EntityY(foot)
		aZ#=EntityZ(foot)
		
		onMap%=(EntityCollided(footCol,2)=world)
		keyL=KeyDown(203) Or KeyDown(30)
		keyR=KeyDown(205) Or KeyDown(32)
		keyU=KeyDown(200) Or KeyDown(17)
		keyD=KeyDown(208) Or KeyDown(31)
		If onMap Then
			xSpeed=xSpeed/2.0
			zSpeed=zSpeed/2.0
			MoveEntity foot,0.075*(keyR-keyL),0,0.075*(keyU-keyD)
		Else
			xSpeed=xSpeed/1.002
			zSpeed=zSpeed/1.002
			MoveEntity foot,0.01*(keyR-keyL),0,0.01*(keyU-keyD)
			If keyR Or keyL Or keyU Or keyD Then
				xSpeed=xSpeed/1.05
				zSpeed=zSpeed/1.05
			End If
		EndIf
		
		If EntityCollided(foot,8)=water Then
			printText "Leider gestorben",255,100,80,0,0,0,cam
			restart=True
			Exit
		End If
		If won And ChannelPlaying(channel)=0 Then
			nextlevel=True
			Exit
		End If
		
		If (keyL Or keyR Or keyU Or keyD) And onMap Then
			RotateEntity weapon,4-2*Cos(360*MilliSecs()/1000.0),0,0
		Else
			RotateEntity weapon,0,0,0
		End If
		
		If KeyDown(57) And onMap Then ySpeed=0.201
		ySpeed=ySpeed-0.01
		TranslateEntity foot,xSpeed,ySpeed,zSpeed
		xSpeed=xSpeed/1.01
		zSpeed=zSpeed/1.01
		
		mys#=MouseYSpeed()/5.0
		If EntityPitch(cam)+mys>90 Then mys=90-EntityPitch(cam)
		If EntityPitch(cam)+mys<-90 Then mys=-90-EntityPitch(cam)
		TurnEntity cam,mys,0,0
		RotateEntity cam,EntityPitch(cam),0,0
		TurnEntity foot,0,-MouseXSpeed()/5.0,0
		MoveMouse xmax/2,ymax/2
		
		If p1on And p2on Then
			HideEntity cam
			ShowEntity portalcam
			
			EntityAlpha portal1,1
			EntityAlpha portal2,1
			
			fac#=0.9
			posx#=EntityX(portal2)
			posy#=EntityY(portal2)
			posz#=EntityZ(portal2)
			pitch#=EntityPitch(portal2)
			yaw#=EntityYaw(portal2)
			roll#=EntityRoll(portal2)
			PositionEntity portalcam,posx,posy,posz
			RotateEntity portalcam,pitch,yaw,roll
			TurnEntity portalcam,0,180,0
			If Abs(Int(EntityPitch(portal1)+0.5))<>90 Then 
				TurnEntity portalcam,-fac*EntityPitch(portal1),-fac*EntityYaw(portal1),0
				TurnEntity portalcam,0,fac*VectorYaw(EntityX(portal1)-EntityX(cam,1),EntityY(portal1)-EntityY(cam,1),EntityZ(portal1)-EntityZ(cam,1)),0
				TurnEntity portalcam,fac*VectorPitch(EntityX(portal1)-EntityX(cam,1),EntityY(portal1)-EntityY(cam,1),EntityZ(portal1)-EntityZ(cam,1)),0,0
			EndIf
			CameraViewport portalcam,0,0,512,512
			RenderWorld
			CopyRect 0,0,512,512,0,0,BackBuffer(),TextureBuffer(portal1tex)
			
			posx#=EntityX(portal1)
			posy#=EntityY(portal1)
			posz#=EntityZ(portal1)
			pitch#=EntityPitch(portal1)
			yaw#=EntityYaw(portal1)
			roll#=EntityRoll(portal1)
			PositionEntity portalcam,posx,posy,posz
			RotateEntity portalcam,pitch,yaw,roll
			TurnEntity portalcam,0,180,0
			If Abs(Int(EntityPitch(portal2)+0.5))<>90 Then 
				TurnEntity portalcam,-fac*EntityPitch(portal2),-fac*EntityYaw(portal2),0
				TurnEntity portalcam,0,fac*VectorYaw(EntityX(portal2)-EntityX(cam,1),EntityY(portal2)-EntityY(cam,1),EntityZ(portal2)-EntityZ(cam,1)),0
				TurnEntity portalcam,fac*VectorPitch(EntityX(portal2)-EntityX(cam,1),EntityY(portal2)-EntityY(cam,1),EntityZ(portal2)-EntityZ(cam,1)),0,0
			EndIf
			RenderWorld
			CopyRect 0,0,512,512,0,0,BackBuffer(),TextureBuffer(portal2tex)
			
			HideEntity portalcam
			ShowEntity cam
		ElseIf p1on Then
			EntityAlpha portal1,0
		ElseIf p2on Then
			EntityAlpha portal2,0
		End If
		
		HideEntity footCol
		PositionEntity footCol,aX,aY,aZ,1
		ShowEntity footCol
		PositionEntity footCol,0,-0.5,0
		PositionEntity footP,0,0,0
		PositionEntity cam,0,1.5,0
		PositionEntity light,EntityX(cam,1),EntityY(cam,1)+2,EntityZ(cam,1)
		UpdateWorld
		RenderWorld
		
		mh1=MouseHit(1)
		mh2=MouseHit(2)
		If CameraPick(cam,xmax/2,ymax/2)=mask Then
			Color 255,255,255
			Rect xmax/2-22,ymax/2-22,44,44,0
			por%=0
			If mh1 Then
				por=portal1
				ShowEntity portal1
				p1on=True
			End If
			If mh2 Then
				por=portal2
				ShowEntity portal2
				p2on=True
			End If
			If por Then
				x#=PickedX()
				y#=PickedY()
				z#=PickedZ()
				PositionEntity por,x,y,z
				RotateEntity por,0,0,0
				AlignToVector por,-PickedNX(),-PickedNY(),-PickedNZ(),3
				If Int(EntityPitch(por)+0.5)=90 Or Int(EntityPitch(por)+0.5)=-90 Then
					For i%=0 To 8
						AlignToVector por,EntityX(cam,1)-x,EntityY(cam,1)-y,EntityZ(cam,1)-z,2
						AlignToVector por,-PickedNX(),-PickedNY(),-PickedNZ(),3
					Next
				End If
			EndIf
		End If
		Color 255,255,255
		Oval xmax/2-2,ymax/2-2,4,4
		Color 0,0,255
		Rect xmax/2-20,ymax/2-20,15,40,0
		If p1on Then Rect xmax/2-18,ymax/2-18,11,36
		Color 255,0,0
		Rect xmax/2+5,ymax/2-20,15,40,0
		If p2on Then Rect xmax/2+7,ymax/2-18,11,36
		
		If KeyHit(25) Or KeyHit(1) Then
			r%=printText("Pause",200,200,200,0,0,0,cam,True,True)
			KeyHit(25)
			KeyHit(1)
			MouseXSpeed
			MouseYSpeed
			MoveMouse xmax/2,ymax/2
			If r Then Exit
		End If
		
		If showpos Then
			x#=EntityX(foot)
			y#=EntityY(foot)
			z#=EntityZ(foot)
			Text 0,0,x
			Text 0,10,y
			Text 0,20,z
		EndIf
		
		xSpeed=EntityX(foot)-aX
		ySpeed=EntityY(foot)-aY
		zSpeed=EntityZ(foot)-aZ
		Flip
		WaitTimer timer
	Wend
	
	If nextlevel Then
		If FileType("voice"+(lvl+1)+".txt")=1 Then
			printtext "",255,255,255,0,0,0,cam
		Else
			printText "Ende",255,255,255,0,0,0,cam
		End If
	EndIf
	
	StopChannel channel
	FreeEntity foot
	FreeEntity portal1
	FreeTexture portal1tex
	FreeEntity portal2
	FreeTexture portal2tex
	FreeEntity portalcam
	FreeEntity world
	FreeEntity mask
	FreeEntity door
	FreeEntity water
	FreeSound music
	For v.TVoice=Each TVoice
		Delete v
	Next
	FreeImage maskImg
	If restart Then rungame lvl
	If nextlevel Then
		If FileType("voice"+(lvl+1)+".txt")=1 Then
			showlogo
			rungame lvl+1
		End If
	EndIf
	ShowPointer
End Function

Function printText%(txt$,colR%,colG%,colB%,bgR,bgG%,bgB%,cam%,in%=True,wait%=False)
	sp%=CreateSprite(2,2,cam)
	PositionEntity sp,0,0,1
	EntityColor sp,bgR,bgG,bgB
	EntityOrder sp,-1
	ms=MilliSecs()
	bfont=LoadFont("Century Gothic",40)
	If wait Then
		ShowPointer
		cmdBack.TButton=createButton("Zurck zum Spiel",xmax/2-ImageWidth(cmdImg)/2,ymax/2+30,cmdImg)
		cmdClose.TButton=createButton("Spiel verlassen",xmax/2-ImageWidth(cmdImg)/2,ymax/2+ImageHeight(cmdImg)+40,cmdImg)
	End If
	close%=0
	While GetKey()<>0
	Wend
	While Not (KeyHit(1) Or GetKey())
		a#=(MilliSecs()-ms)/2000.0
		If in Then
			If a>2 And wait=False Then Exit
		Else
			a=1-a
			If a<=0 And wait=False Then Exit
		EndIf
		If wait And a>0.5 Then a=0.5
		EntityAlpha sp,a
		RenderWorld
		If a>0.25 Then
			Color colR,colG,colB
			SetFont bfont
			Text xmax/2-StringWidth(txt)/2,ymax/2-StringHeight(txt)/2,txt
			SetFont font
			If wait
				mh=MouseHit(1)
				updatebutton cmdBack,mh
				updatebutton cmdClose,mh
				If fullscreen Then DrawImage mouse,MouseX(),MouseY()
				If cmdBack\hit Then
					close=0
					Exit
				ElseIf cmdClose\hit Then
					close=1
					Exit
				EndIf
			End If
		EndIf
		Flip
		WaitTimer timer
	Wend
	If wait Then
		Delete cmdBack
		Delete cmdClose
		HidePointer
	EndIf
	FreeFont bfont
	FreeEntity sp
	Return close
End Function

Function createPortalSurface%(sizeX#,sizeY#,par%=0)
	mesh=CreateMesh(par)
	surf=CreateSurface(mesh)
	baseV=AddVertex(surf,0,0,0,0.5,0.5)
	lastV=AddVertex(surf,sizeX,0,0,1,0.5)
	av0=lastV
	For i%=10 To 350 Step 10
		v0=AddVertex(surf,Cos(i)*sizeX,-Sin(i)*sizeY,0,0.5+0.5*Cos(i),0.5+0.5*Sin(i))
		AddTriangle(surf,lastV,v0,baseV)
		lastV=v0
	Next
	AddTriangle(surf,lastV,av0,baseV)
	Return mesh
End Function

Function CreateSprite%(sizeX#,sizeY#,par%=0)
	mesh%=CreateMesh(par)
	surf%=CreateSurface(mesh)
	v0=AddVertex(surf,-sizeX,sizeY,0,0,0)
	v1=AddVertex(surf,sizeX,sizeY,0,1,0)
	v2=AddVertex(surf,-sizeX,-sizeY,0,0,1)
	v3=AddVertex(surf,sizeX,-sizeY,0,1,1)
	AddTriangle surf,v0,v1,v2
	AddTriangle surf,v1,v3,v2
	Return mesh
End Function

Function getNonsense$()
	file=ReadFile("nonsense.txt")
	n%=Int(ReadLine(file))
	s%=Rand(0,n-1)
	While s>0
		ReadLine(file)
		s=s-1
	Wend
	res$=ReadLine(file)
	CloseFile file
	Return res
End Function

Type TVoice
	Field sound%
	Field posx#
	Field posy#
	Field posz#
End Type